/*
 * Dictionary.c
 *
 *  Created on: 2009/07/08
 *      Author: ashida
 */

#include <stdio.h>
#include <stdlib.h>
#include <Dictionary.h>
#include <Feature.h>

/* vfǉ */
static void _addElement(Dictionary *dictionary, DictionaryElement *element);

/*---------------------------------------------------------------------------*/
/*  */
void initDictionary(Dictionary *dictionary, unsigned int dimension){
	dictionary->allocElementNum = INIT_DICT_ELEMENT_NUM;
	dictionary->elementNum = 0;
	dictionary->dimension = dimension;
	dictionary->elements = (DictionaryElement **)malloc(sizeof(DictionaryElement *)*dictionary->allocElementNum);
}
/*---------------------------------------------------------------------------*/
/* vfݒ肷 */
void setElementNum(Dictionary *dictionary, unsigned int element_num){
	dictionary->elementNum = element_num;
}
/*---------------------------------------------------------------------------*/
/* ɒǉ */
void addElement(Dictionary *dictionary, unsigned int code, unsigned int *feature){
	/* ̗vf */
	DictionaryElement *element;
	/* vf̃m */
	element = allocDictionaryElement();

	/* vfɕR[hݒ肷 */
	setCode(element, code);
	/* vfɓʂݒ肷 */
	setFeature(element, feature);
	/* vfǉ */
	_addElement(dictionary, element);
	/* vfJEgAbv */
	dictionary->elementNum++;
}
/*---------------------------------------------------------------------------*/
/* ̃̉ */
void freeDictionary(Dictionary *dictionary){
	/* ϐ */
	int i;

	/* vf̉ */
	for(i=0; i<dictionary->elementNum; i++){
		freeDictionaryElement(dictionary->elements[i]);
	}

	/* vf̏W܂̉ */
	free(dictionary->elements);
}
/*---------------------------------------------------------------------------*/
/* ۑ */
void writeDictionary(Dictionary *dictionary, char *filename){
	/* t@C|C^ */
	FILE *fp;
	/* ϐ */
	unsigned int i;

	/* t@CI[v */
	fp = fopen(filename, "w");

	/* vfiTvjCʂ̎o */
	fprintf(fp, "%d %d\n", dictionary->elementNum, dictionary->dimension);
	for(i=0; i<dictionary->elementNum; i++){
		/* vfۑ */
		writeDictionaryElement(dictionary->elements[i], dictionary->dimension, fp);
	}

	/* t@CN[Y */
	fclose(fp);
}
/*---------------------------------------------------------------------------*/
/* ǂݍ */
void readDictionary(Dictionary *dictionary, char *filename){
	/* t@C|C^ */
	FILE *fp;
	/* ϐ */
	unsigned int i;

	/* t@CI[v */
	fp = fopen(filename, "r");

	/* vfiTvjCʂ̎ǂݍ */
	fscanf(fp, "%d %d\n", &(dictionary->elementNum), &(dictionary->dimension));
	/* vfƓCvf̂߂̃mۂ */
	dictionary->allocElementNum = dictionary->elementNum;
	dictionary->elements = (DictionaryElement **)realloc((DictionaryElement **)dictionary->elements, sizeof(DictionaryElement *)*dictionary->allocElementNum);

	/* vfJԂ */
	for(i=0; i<dictionary->elementNum; i++){
		/* vf̃m */
		dictionary->elements[i] = allocDictionaryElement();
		/* vfǂݍ */
		readDictionaryElement(dictionary->elements[i], dictionary->dimension, fp);
	}

	/* t@CN[Y */
	fclose(fp);

}
/*---------------------------------------------------------------------------*/
/* w肳ꂽʂ𓾂 */
unsigned int *getFeature(Dictionary *dictionary, int id){
	return dictionary->elements[id]->feature;
}
/*---------------------------------------------------------------------------*/
/* o^Ăvf𓾂 */
unsigned int getElementNum(Dictionary *dictionary){
	return dictionary->elementNum;
}
/*---------------------------------------------------------------------------*/
/* R[h𓾂 */
unsigned int getCode(Dictionary *dictionary, unsigned int id){
	return dictionary->elements[id]->code;
}
/*---------------------------------------------------------------------------*/
/******************** */
/* static֐ */
/******************** */
/* vfǉ */
static void _addElement(Dictionary *dictionary, DictionaryElement *element){
	/* vf̂߂ɊmۂĂ郁ʂȂꍇ */
	if(dictionary->elementNum+1 > dictionary->allocElementNum){
		/* VɊmۂ郁ʂ͂܂ł2{Ƃ */
		dictionary->allocElementNum *= 2;
		/* Ċmۂ */
		dictionary->elements = (DictionaryElement **)realloc((DictionaryElement **)dictionary->elements, sizeof(DictionaryElement *)*dictionary->allocElementNum);
	}
	/* vfǉ */
	dictionary->elements[dictionary->elementNum] = element;
}
